#version 150

#moj_import <matrix.glsl>

uniform sampler2D Sampler0;
uniform sampler2D Sampler1;

uniform float GameTime;
uniform int EndPortalLayers;

in vec4 texProj0;

const vec3[] COLORS = vec3[](


    vec3(0.114,0.043,0.133),

    vec3(0.01,0.01,0.01),

    vec3(0.086,0.141,0.173),

    vec3(0.01,0.01,0.01),

    vec3(0.051,0.09,0.11),

    vec3(0.01,0.01,0.01),

    vec3(0.01,0.01,0.01),

    vec3(0.01,0.01,0.01),

    vec3(0.01,0.01,0.01),

    vec3(0.01,0.01,0.01),

    vec3(0.051,0.325,0.263),

    vec3(0.01,0.01,0.01),

    vec3(0.263,0.184,0.298),

    vec3(0.004,0.42,0.322),

    vec3(0.067,0.02,0.078),

    vec3(0.901,0.901,0.901)

);

const mat4 SCALE_TRANSLATE = mat4(
    0.5, 0.0, 0.0, 0.25,
    0.0, 0.5, 0.0, 0.25,
    0.0, 0.0, 1.0, 0.0,
    0.0, 0.0, 0.0, 1.0
);

mat4 end_portal_layer(float layer) {
    mat4 translate = mat4(
        1.0, 0.0, 0.0, 17.0 / layer,
        0.0, 1.0, 0.0, (2.0 + layer / 1.5) * (GameTime * 1.5),
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
    );

    mat2 rotate = mat2_rotate_z(radians((layer * layer * 4321.0 + layer * 9.0) * 2.0));

    mat2 scale = mat2((4.5 - layer / 4.0) * 2.0);

    return mat4(scale * rotate) * translate * SCALE_TRANSLATE;
}

out vec4 fragColor;

void main() {
    vec3 color = textureProj(Sampler0, texProj0).rgb * COLORS[0];
    for (int i = 0; i < EndPortalLayers; i++) {
        color += textureProj(Sampler1, texProj0 * end_portal_layer(float(i + 1))).rgb * COLORS[i];
    }
    fragColor = vec4(color, 1);
}
