#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    if (color.a < 0.1) {
        discard;
    }
 

/*
color.a = 1;
*/




/*
if(color.r <= 256/255.0 && color.r > -1/255.0 && color.g <= 256/255.0 && color.g > -1/255.0 && color.b <= 256/255.0 && color.b > -1/255.0){
color = vec4(0.902, 0.9686, 0.2941, 1);
}
*/




/* XP for Enchanting Table/Anvil/XP Bar Color */
if(color.r <= 126.50/255.0 && color.r > 126.49/255.0 && color.g == 252/255.0 && color.b <= 31.63/255.0 && color.b > 31.62/255.0){
color = vec4(0.302, 0.7686, 0.6941, 1);
}




/* Header Text Color */
if(color.r <= 64/255.0 && color.r > 62/255.0 && color.g <= 64/255.0 && color.g > 62/255.0 && color.b <= 64/255.0 && color.b > 62/255.0){
color = vec4(0.2784, 0.1569, 0.1922, 0.85);
}





/* Title Splash Yellow */
if(color.r <= 256/255.0 && color.r > 251/255.0 && color.g <= 256/255.0 && color.g > 251/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.5922, 0.3686, 0.5843, 0.85);
}

/* Title Splash Yellow Shadow*/
if(color.r <= 63/255.0 && color.r > 61/255.0 && color.g <= 63/255.0 && color.g > 61/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.1686, 0.1686, 0.1804, 0.8);
}






/* Red Text Color */
if(color.r <= 256/255.0 && color.r > 251/255.0 && color.g <= 86/255.0 && color.g > 83/255.0 && color.b <= 86/255.0 && color.b > 83/255.0){
color = vec4(0.7882, 0.3647, 0.3765, 1);
}

/* Red Text Color Shadow */
if(color.r <= 63/255.0 && color.r > 61/255.0 && color.g <= 22/255.0 && color.g > 20/255.0 && color.b <= 22/255.0 && color.b > 20/255.0){
color = vec4(0.1843, 0.0863, 0.1373, 0.5);
}

/* Dark Red Text Color */
if(color.r <= 171/255.0 && color.r > 167/255.0 && color.g <= 1/255.0 && color.g > -1/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.5647, 0.2863, 0.3176, 1);
}

/* Dark Red Text Color Shadow */
if(color.r <= 63/255.0 && color.r > 61/255.0 && color.g <= 22/255.0 && color.g > 20/255.0 && color.b <= 22/255.0 && color.b > 20/255.0){
color = vec4(0.1843, 0.0863, 0.1373, 0.5);
}



/* Gold Text Color */
if(color.r <= 256/255.0 && color.r > 251/255.0 && color.g <= 171/255.0 && color.g > 167/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.851, 0.6784, 0.2824, 1);
}

/* Gold Text Color Shadow */
if(color.r <= 63/255.0 && color.r > 61/255.0 && color.g <= 63/255.0 && color.g > 61/255.0 && color.b <= 22/255.0 && color.b > 20/255.0){
color = vec4(0.1725, 0.1373, 0.0902, 0.5);
}



/* Yellow Text Color */
if(color.r <= 256/255.0 && color.r > 251/255.0 && color.g <= 256/255.0 && color.g > 251/255.0 && color.b <= 86/255.0 && color.b > 83/255.0){
color = vec4(1, 0.8902, 0.3686, 1);
}

/* Yellow Text Color Shadow */
if(color.r <= 63/255.0 && color.r > 61/255.0 && color.g <= 63/255.0 && color.g > 61/255.0 && color.b <= 22/255.0 && color.b > 20/255.0){
color = vec4(0.1725, 0.1373, 0.0902, 0.5);
}



/* Green Text Color */
if(color.r <= 86/255.0 && color.r >= 83/255.0 && color.g <= 256/255.0 && color.g >= 251/255.0 && color.b <= 86/255.0 && color.b >= 83/255.0){
color = vec4(0.6824, 0.6902, 0.1725, 1);
}

/* Green Text Color Shadow */
if(color.r <= 23/255.0 && color.r > 19/255.0 && color.g <= 65/255.0 && color.g > 61/255.0 && color.b <= 23/255.0 && color.b > 19/255.0){
color = vec4(0.2, 0.2157, 0.1569, 0.75);
} 

/* Green Text Color Shadow */
if(color.r <= 1/255.0 && color.r > -1/255.0 && color.g <= 43/255.0 && color.g > 41/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.2, 0.2157, 0.1569, 0.5);
}

/* Dark Green Text Color */
if(color.r <= 1/255.0 && color.r > -1/255.0 && color.g <= 171/255.0 && color.g > 167/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.5412, 0.5451, 0.1373, 1);
}

/* Dark Green Text Color Shadow */
if(color.r <= 1/255.0 && color.r > -1/255.0 && color.g <= 43/255.0 && color.g > 41/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.2, 0.2157, 0.1569, 0.5);
}



/* Aqua Text Color */
if(color.r <= 86/255.0 && color.r > 83/255.0 && color.g <= 256/255.0 && color.g > 251/255.0 && color.b <= 256/255.0 && color.b > 251/255.0){
color = vec4(0.549, 0.7686, 0.4824, 1);
}

/* Aqua Text Color Shadow */
if(color.r <= 22/255.0 && color.r > 20/255.0 && color.g <= 63/255.0 && color.g > 61/255.0 && color.b <= 63/255.0 && color.b > 61/255.0){
color = vec4(0.1255, 0.1569, 0.1686, 0.5);
}

/* Dark Aqua Text Color */
if(color.r <= 1/255.0 && color.r > -1/255.0 && color.g <= 169/255.0 && color.g > 167/255.0 && color.b <= 169/255.0 && color.b > 167/255.0){
color = vec4(0.2745, 0.5961, 0.4392, 1);
}

/* Dark Aqua Text Color Shadow */
if(color.r <= 22/255.0 && color.r > 20/255.0 && color.g <= 63/255.0 && color.g > 61/255.0 && color.b <= 63/255.0 && color.b > 61/255.0){
color = vec4(0.1255, 0.1569, 0.1686, 0.5);
}



/* Blue Text Color */
if(color.r <= 86/255.0 && color.r > 83/255.0 && color.g <= 86/255.0 && color.g > 83/255.0 && color.b <= 256/255.0 && color.b > 251/255.0){
color = vec4(0.302, 0.7686, 0.6941, 1);
}

/* Blue Text Color Shadow */
if(color.r <= 22/255.0 && color.r > 20/255.0 && color.g <= 22/255.0 && color.g > 20/255.0 && color.b <= 63/255.0 && color.b > 61/255.0){
color = vec4(0.1255, 0.1569, 0.1686, 0.5);
}

/* Dark Blue Text Color */
if(color.r <= 1/255.0 && color.r > -1/255.0 && color.g <= 1/255.0 && color.g > -1/255.0 && color.b <= 171/255.0 && color.b > 167/255.0){
color = vec4(0.0157, 0.502, 0.6431, 1);
}

/* Dark Blue Text Color Shadow */
if(color.r <= 22/255.0 && color.r > 20/255.0 && color.g <= 63/255.0 && color.g > 61/255.0 && color.b <= 63/255.0 && color.b > 61/255.0){
color = vec4(0.1255, 0.1569, 0.1686, 0.5);
}



/* Purple Text Color */
if(color.r <= 256/255.0 && color.r > 251/255.0 && color.g <= 86/255.0 && color.g > 83/255.0 && color.b <= 256/255.0 && color.b > 251/255.0){
color = vec4(0.749, 0.3882, 0.6196, 1);
}

/* Purple Text Color Shadow */
if(color.r <= 64/255.0 && color.r > 62/255.0 && color.g <= 22/255.0 && color.g > 20/255.0 && color.b <= 64/255.0 && color.b > 62/255.0){
color = vec4(0.1961, 0.1059, 0.2039, 0.5);
}

/* Dark Purple Text Color */
if(color.r <= 171/255.0 && color.r > 167/255.0 && color.g <= 1/255.0 && color.g > -1/255.0 && color.b <= 171/255.0 && color.b > 167/255.0){
color = vec4(0.5922, 0.3686, 0.5843, 1);
}

/* Dark Purple Text Color Shadow */
if(color.r <= 51/255.0 && color.r > 40/255.0 && color.g <= 16/255.0 && color.g > -1/255.0 && color.b <= 44/255.0 && color.b > 40/255.0){
color = vec4(0.1608, 0, 0.1569, 0.5);
}




/* Black Text Color */
if(color.r <= 1/255.0 && color.r > -1/255.0 && color.g <= 1/255.0 && color.g > -1/255.0 && color.b <= 1/255.0 && color.b > -1/255.0){
color = vec4(0.2118, 0.1569, 0.1608, 1);
}



/* Dark Gray Text Color */
if(color.r <= 85/255.0 && color.r > 83/255.0 && color.g <= 85/255.0 && color.g > 83/255.0 && color.b <= 85/255.0 && color.b > 83/255.0){
color = vec4(0.5412, 0.4235, 0.4, 1);
}

/* Dark Gray Text Color Shadow */
if(color.r <= 22/255.0 && color.r > 20/255.0 && color.g <= 22/255.0 && color.g > 20/255.0 && color.b <= 22/255.0 && color.b > 20/255.0){
color = vec4(0.2118, 0.1569, 0.1608, 0.5);
}


/* Gray Text Color */
if(color.r <= 171/255.0 && color.r > 169/255.0 && color.g <= 171/255.0 && color.g > 169/255.0 && color.b <= 171/255.0 && color.b > 169/255.0){
color = vec4(0.7333, 0.6314, 0.6157, 1);
}

/* Gray Text Color Shadow */
if(color.r <= 42/255.0 && color.r > 40/255.0 && color.g <= 42/255.0 && color.g > 40/255.0 && color.b <= 42/255.0 && color.b > 40/255.0){
color = vec4(0.2118, 0.1569, 0.1608, 0.5);
}


/* Other Gray Text Color */
if(color.r <= 169/255.0 && color.r > 167/255.0 && color.g <= 169/255.0 && color.g > 167/255.0 && color.b <= 169/255.0 && color.b > 167/255.0){
color = vec4(0.7333, 0.6314, 0.6157, 1);
}

/* Other Gray Text Color Shadow */
if(color.r <= 42/255.0 && color.r > 40/255.0 && color.g <= 42/255.0 && color.g > 40/255.0 && color.b <= 42/255.0 && color.b > 40/255.0){
color = vec4(0.2118, 0.1569, 0.1608, 0.5);
}  



/* White Text Color */
if(color.r <= 256/255.0 && color.r > 251/255.0 && color.g <= 256/255.0 && color.g > 251/255.0 && color.b <= 256/255.0 && color.b > 251/255.0){
color = vec4(0.9882, 0.949, 0.9098, 1);
}



/* New Recipe Text Purple 
if(color.r <= 82/255.0 && color.r > 78/255.0 && color.g <= 2/255.0 && color.g > -1/255.0 && color.b <= 82/255.0 && color.b > 78/255.0){
color = vec4(0.3882, 0.2078, 0.2275, 1);
}*/


/* Achievement Text Pink */
if(color.r <= 256/255.0 && color.r > 253/255.0 && color.g <= 138/255.0 && color.g > 134/255.0 && color.b <= 256/255.0 && color.b > 253/255.0){
color = vec4(0.6745, 0.3843, 0.6157, 1);
}


/* Statistics Text Gray */
if(color.r <= 146/255.0 && color.r > 142/255.0 && color.g <= 146/255.0 && color.g > 142/255.0 && color.b <= 146/255.0 && color.b > 142/255.0){
color = vec4(0.8471, 0.7529, 0.7137, 1);
}

/* Statistics Text Gray Shadow */
if(color.r <= 38/255.0 && color.r > 34/255.0 && color.g <= 38/255.0 && color.g > 34/255.0 && color.b <= 38/255.0 && color.b > 34/255.0){
color = vec4(0.2118, 0.1569, 0.1608, 1);
}


/* Statistics Text Gray Too */
if(color.r <= 98/255.0 && color.r > 94/255.0 && color.g <= 98/255.0 && color.g > 94/255.0 && color.b <= 98/255.0 && color.b > 94/255.0){
color = vec4(0.7333, 0.6314, 0.6157, 1);
}

/* Statistics Text Gray Too Shadow */
if(color.r <= 26/255.0 && color.r > 22/255.0 && color.g <= 26/255.0 && color.g > 22/255.0 && color.b <= 26/255.0 && color.b > 22/255.0){
color = vec4(0.1412, 0.1059, 0.1098, 1);
}




/* if(color.r <= 256/255.0 && color.r > -1/255.0 && color.g <= 256/255.0 && color.g > -1/255.0 && color.b <= 256/255.0 && color.b > -1/255.0){
color = vec4(0.902, 0.2686, 0.2941, 1);
} */

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}


